(* client_code.v

   This contains the actual instructions for the factorial client program from
   
   Compiling Functional Types to Relational Specifications for Low Level Imperative Code
   Nick Benton and Nicolas Tabareau

   (c) 2007 Microsoft Research
*)

Require Import programs.

Definition factinstructions (fact alloc dealloc : nat) :=
    Prog_add 1 (i_brz (s_imm 5) (s_cst (fact+17)))
   (Prog_add 2 (i_move (d_imm 1) (s_cst 3))
   (Prog_add 3 (i_move (d_imm 0) (s_cst (fact+4)))
   (Prog_add 4 (i_branch (s_cst alloc))
   (Prog_add 5 (i_move (d_ind 0) (s_imm 5))
   (Prog_add 6 (i_move (d_indo 1 0) (s_imm 6))
   (Prog_add 7 (i_move (d_indo 2 0) (s_imm 7))
   (Prog_add 8 (i_move (d_imm 7) (s_imm 0))
   (Prog_add 9 (i_op minus (d_imm 5) (s_imm 5) (s_cst 1))
   (Prog_add 10 (i_move (d_imm 6) (s_cst (fact+11)))
   (Prog_add 11 (i_branch (s_cst fact))
   (Prog_add 12 (i_op mult (d_imm 5) (s_imm 5) (s_ind 7))
   (Prog_add 13 (i_move (d_imm 0) (s_indo 1 7))
   (Prog_add 14 (i_move (d_imm 2) (s_imm 7))
   (Prog_add 15 (i_move (d_imm 7) (s_indo 2 7))
   (Prog_add 16 (i_move (d_imm 1) (s_cst 3))
   (Prog_add 17 (i_branch (s_cst dealloc))
   (Prog_add 18 (i_move (d_imm 5) (s_cst 1))
   (Prog_add 19 (i_branch (s_imm 6)) empty_prog)))))))))))))))))).
